=begin
#Voucherify API

#Voucherify promotion engine REST API. Please see https://docs.voucherify.io/docs for more details.

The version of the OpenAPI document: v2018-08-01
Contact: support@voucherify.io
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 7.0.1

=end

require 'date'
require 'time'

module VoucherifySdk
  # Request body schema for **POST** `/loyalties`.
  class LoyaltiesCreateCampaignRequestBody
    # Campaign name.
    attr_accessor :name

    # An optional field to keep any extra textual information about the campaign such as a campaign description and details.
    attr_accessor :description

    # Defines whether the campaign can be updated with new vouchers after campaign creation.      - `AUTO_UPDATE`: By choosing the auto update option you will create a campaign that can be enhanced by new vouchers after the time of creation (e.g. by publish vouchers method).     -  `STATIC`: vouchers need to be manually published.
    attr_accessor :type

    # If this value is set to `true`, customers will be able to join the campaign only once.
    attr_accessor :join_once

    # Indicates whether customers will be able to auto-join a loyalty campaign if any earning rule is fulfilled.
    attr_accessor :auto_join

    # Flag indicating whether the campaign is to use the voucher's metadata schema instead of the campaign metadata schema.
    attr_accessor :use_voucher_metadata_schema

    # Total number of unique vouchers in campaign (size of campaign).
    attr_accessor :vouchers_count

    # Activation timestamp defines when the campaign starts to be active in ISO 8601 format. Campaign is *inactive before* this date. 
    attr_accessor :start_date

    # Expiration timestamp defines when the campaign expires in ISO 8601 format.  Campaign is *inactive after* this date.
    attr_accessor :expiration_date

    attr_accessor :validity_timeframe

    # Integer array corresponding to the particular days of the week in which the voucher is valid.  - `0` Sunday - `1` Monday - `2` Tuesday - `3` Wednesday - `4` Thursday - `5` Friday - `6` Saturday
    attr_accessor :validity_day_of_week

    attr_accessor :validity_hours

    # Defines the amount of time the vouchers will be active after publishing. The value is shown in the ISO 8601 format. For example, a voucher with the value of P24D will be valid for a duration of 24 days.
    attr_accessor :activity_duration_after_publishing

    # Unique category ID that this campaign belongs to. Either pass this parameter OR the `category`.
    attr_accessor :category_id

    # The category assigned to the campaign. Either pass this parameter OR the `category_id`.
    attr_accessor :category

    # The metadata object stores all custom attributes assigned to the campaign. A set of key/value pairs that you can attach to a campaign object. It can be useful for storing additional information about the campaign in a structured format.
    attr_accessor :metadata

    # Array containing the ID of the validation rule associated with the promotion tier.
    attr_accessor :validation_rules

    # Type of campaign.
    attr_accessor :campaign_type

    attr_accessor :voucher

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'name' => :'name',
        :'description' => :'description',
        :'type' => :'type',
        :'join_once' => :'join_once',
        :'auto_join' => :'auto_join',
        :'use_voucher_metadata_schema' => :'use_voucher_metadata_schema',
        :'vouchers_count' => :'vouchers_count',
        :'start_date' => :'start_date',
        :'expiration_date' => :'expiration_date',
        :'validity_timeframe' => :'validity_timeframe',
        :'validity_day_of_week' => :'validity_day_of_week',
        :'validity_hours' => :'validity_hours',
        :'activity_duration_after_publishing' => :'activity_duration_after_publishing',
        :'category_id' => :'category_id',
        :'category' => :'category',
        :'metadata' => :'metadata',
        :'validation_rules' => :'validation_rules',
        :'campaign_type' => :'campaign_type',
        :'voucher' => :'voucher'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'name' => :'String',
        :'description' => :'String',
        :'type' => :'String',
        :'join_once' => :'Boolean',
        :'auto_join' => :'Boolean',
        :'use_voucher_metadata_schema' => :'Boolean',
        :'vouchers_count' => :'Integer',
        :'start_date' => :'Time',
        :'expiration_date' => :'Time',
        :'validity_timeframe' => :'ValidityTimeframe',
        :'validity_day_of_week' => :'Array<Integer>',
        :'validity_hours' => :'ValidityHours',
        :'activity_duration_after_publishing' => :'String',
        :'category_id' => :'String',
        :'category' => :'String',
        :'metadata' => :'Object',
        :'validation_rules' => :'Array<String>',
        :'campaign_type' => :'String',
        :'voucher' => :'CampaignLoyaltyVoucher'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'name',
        :'description',
        :'type',
        :'join_once',
        :'auto_join',
        :'use_voucher_metadata_schema',
        :'vouchers_count',
        :'start_date',
        :'expiration_date',
        :'activity_duration_after_publishing',
        :'category_id',
        :'category',
        :'metadata',
        :'validation_rules',
        :'campaign_type',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        h[k.to_sym] = v
      }

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.key?(:'join_once')
        self.join_once = attributes[:'join_once']
      end

      if attributes.key?(:'auto_join')
        self.auto_join = attributes[:'auto_join']
      end

      if attributes.key?(:'use_voucher_metadata_schema')
        self.use_voucher_metadata_schema = attributes[:'use_voucher_metadata_schema']
      end

      if attributes.key?(:'vouchers_count')
        self.vouchers_count = attributes[:'vouchers_count']
      end

      if attributes.key?(:'start_date')
        self.start_date = attributes[:'start_date']
      end

      if attributes.key?(:'expiration_date')
        self.expiration_date = attributes[:'expiration_date']
      end

      if attributes.key?(:'validity_timeframe')
        self.validity_timeframe = attributes[:'validity_timeframe']
      end

      if attributes.key?(:'validity_day_of_week')
        if (value = attributes[:'validity_day_of_week']).is_a?(Array)
          self.validity_day_of_week = value
        end
      end

      if attributes.key?(:'validity_hours')
        self.validity_hours = attributes[:'validity_hours']
      end

      if attributes.key?(:'activity_duration_after_publishing')
        self.activity_duration_after_publishing = attributes[:'activity_duration_after_publishing']
      end

      if attributes.key?(:'category_id')
        self.category_id = attributes[:'category_id']
      end

      if attributes.key?(:'category')
        self.category = attributes[:'category']
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'validation_rules')
        if (value = attributes[:'validation_rules']).is_a?(Array)
          self.validation_rules = value
        end
      end

      if attributes.key?(:'campaign_type')
        self.campaign_type = attributes[:'campaign_type']
      else
        self.campaign_type = 'LOYALTY_PROGRAM'
      end

      if attributes.key?(:'voucher')
        self.voucher = attributes[:'voucher']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if !@validation_rules.nil? && @validation_rules.length > 1
        invalid_properties.push('invalid value for "validation_rules", number of items must be less than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      type_validator = EnumAttributeValidator.new('String', ["AUTO_UPDATE", "STATIC"])
      return false unless type_validator.valid?(@type)
      return false if !@validation_rules.nil? && @validation_rules.length > 1
      campaign_type_validator = EnumAttributeValidator.new('String', ["LOYALTY_PROGRAM"])
      return false unless campaign_type_validator.valid?(@campaign_type)
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          description == o.description &&
          type == o.type &&
          join_once == o.join_once &&
          auto_join == o.auto_join &&
          use_voucher_metadata_schema == o.use_voucher_metadata_schema &&
          vouchers_count == o.vouchers_count &&
          start_date == o.start_date &&
          expiration_date == o.expiration_date &&
          validity_timeframe == o.validity_timeframe &&
          validity_day_of_week == o.validity_day_of_week &&
          validity_hours == o.validity_hours &&
          activity_duration_after_publishing == o.activity_duration_after_publishing &&
          category_id == o.category_id &&
          category == o.category &&
          metadata == o.metadata &&
          validation_rules == o.validation_rules &&
          campaign_type == o.campaign_type &&
          voucher == o.voucher
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [name, description, type, join_once, auto_join, use_voucher_metadata_schema, vouchers_count, start_date, expiration_date, validity_timeframe, validity_day_of_week, validity_hours, activity_duration_after_publishing, category_id, category, metadata, validation_rules, campaign_type, voucher].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = VoucherifySdk.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
